<template>
	<div>
		<div
			class="w-full md:w-690 lg:w-580 bg-white px-4 py-10 md:px-10 md:pt-10 md:pb-8 lg:px-14 lg:pt-14 lg:pb-14 mx-auto"
		>
			<div class="flex items-center">
				<MkSuccessIcon :icon-black="false" aria-label="Your order is confirmed" />
				<h2
					class="font-secondary-font-regular text-2xl md:text-28 lg:text-base2 leading-7 md:leading-8 lg:leading-10 pl-4 lg:pl-6"
				>
					Your order is confirmed.
				</h2>
			</div>
			<div class="flex justify-between font-primary-font-light text-base leading-6 w-full mt-10 md:mt-9 lg:mt-12">
				<p>Order #{{ orderNumber }}</p>
				<p v-if="ORDER.custom && ORDER.custom.fields && ORDER.custom.fields.gift" class="flex justify-between">
					<span class="mr-1">This is a gift</span>&nbsp;<span><MkGiftIcon /></span>
				</p>
			</div>
			<p class="font-primary-font-light text-base leading-6 mt-6 md:mt-8">
				We’re getting your order ready. Look out for email updates on your order status and managing your account.
			</p>
			<div v-for="(item, index) in itemData" :key="index" class="flex mt-10 md:mt-8 lg:mt-12 flex-col">
				<div class="flex flex-row">
					<div class="flex mr-4">
						<div class="flex justify-center items-start">
							<MKProductImage size-class="w-75 h-75" :product-name="item.name[apiLocale]" :product-detail="item" />
						</div>
					</div>
					<div class="flex flex-col w-full text-black">
						<!-- <h2 class="text-base leading-6 font-primary-font-bold">{{item.name['en-US']}}</h2>
                        <p v-if="!isFilter(item) && !GIFT && item.cartItemHasSubscription"  class="font-primary-font-light text-base leading-6 md:mt-2 lg:mt-0">Includes {{ item['cartItemSubscriptionData']['period'] }} mos. of filters</p> -->
						<div class="md:flex flex-row justify-between">
							<div class="flex justify-between flex-col">
								<h3 class="text-xl leading-6 font-secondary-font-regular">
									{{ item.name[apiLocale] }}
								</h3>
								<span
									v-if="
										!isFilter(item) &&
										ORDER.custom &&
										ORDER.custom.fields &&
										!ORDER.custom.fields.gift &&
										item.cartItemHasSubscription &&
										FEATURE_SUBSCRIPTION
									"
									class="screen-reader-only"
									>Includes {{ item['cartItemSubscriptionData']['period'] }}months of filters</span
								>
								<p
									v-if="
										!isFilter(item) &&
										ORDER.custom &&
										ORDER.custom.fields &&
										!ORDER.custom.fields.gift &&
										item.cartItemHasSubscription &&
										FEATURE_SUBSCRIPTION
									"
									class="font-primary-font-light text-base leading-6 md:mt-2 lg:mt-0"
									aria-hidden="”true”"
								>
									Includes {{ item['cartItemSubscriptionData']['period'] }} mos. of filters
								</p>
								<span
									v-if="
										ORDER.custom &&
										ORDER.custom.fields &&
										!ORDER.custom.fields.gift &&
										item.cartItemHasSubscription &&
										FEATURE_SUBSCRIPTION
									"
								>
									<MKFilterSubscription :item="item" :show-tooltip="true" :show-includes="false" />
								</span>
								<div class="flex-row md:flex justify-between">
									<p
										class="flex text-base md:text-sm lg:text-base leading-6 md:leading-5 lg:leading-6 md:mt-2 lg:mt-0 font-primary-font-light md:font-primary-font-regular lg:font-primary-font-light"
									>
										<span>Qty: </span>
										<span>{{ item.quantity }}</span>
									</p>
								</div>
							</div>
							<div
								class="flex text-base font-primary-font-bold lg:font-primary-font-regular leading-6 lg:leading-5 md:justify-end"
							>
								<div class="flex flex-col md:justify-end">
									<MkAffirmLogo
										v-if="
											ORDER.paymentInfo &&
											ORDER.paymentInfo.payments[0] &&
											ORDER.paymentInfo.payments[0].obj &&
											ORDER.paymentInfo.payments[0].obj.paymentMethodInfo &&
											ORDER.paymentInfo.payments[0].obj.paymentMethodInfo.method == 'AFFIRM'
										"
										class="mt-1 md:mt-0"
									/>
								</div>
							</div>
						</div>
					</div>
				</div>
				<MkClydeButton v-if="FEATURE_CLYDE" :is-checkout="true" :item="item" />
			</div>
			<MkOrderTotal class="mt-10 md:mt-8 lg:mt-14" :from-success="true" :discount="false" />
			<MkOrder :from-success="true" />
		</div>
	</div>
</template>
<script>
import { mapState } from 'vuex';
import MkSuccessIcon from '~/components/D2C/atoms/MkSuccessIcon.vue';
import MkOrderTotal from '~/components/D2C/molecules/MkOrderTotal.vue';
import MKProductImage from '~/components/D2C/organisms/MkProductImage/MkProductImage.vue';
import MkOrder from '~/components/D2C/molecules/MkOrder.vue';
import MKFilterSubscription from '~/components/D2C/molecules/MkFilterSubscription/MkFilterSubscription.vue';
import MkGiftIcon from '~/components/D2C/atoms/MkGiftIcon.vue';
import MkClydeButton from '~/components/D2C/atoms/MkClydeButton.vue';
import MkAffirmLogo from '~/components/D2C/atoms/MkAffirmLogo.vue';
export default {
	name: 'MkConfirmation',
	components: {
		MkSuccessIcon,
		MkOrderTotal,
		MKProductImage,
		MkOrder,
		MKFilterSubscription,
		MkGiftIcon,
		MkClydeButton,
		MkAffirmLogo,
	},
	props: {},
	data() {
		return {
			isOrderConfirmed: false,
			isOrderPendingFreightMissing: false,
			isOrderTermsPending: false,
			isOrderTaxPending: false,
			isOrderAchPaymentPending: false,
		};
	},
	computed: {
		...mapState('USER_STORE', ['ORDER']),
		...mapState('CART_STORE', ['CART_ID']),
		...mapState('CHECKOUT_STORE', ['FEATURE_CLYDE', 'FEATURE_SUBSCRIPTION']),
		...mapState(['currencyDisplay', 'isEurope', 'apiLocale']),
		itemData: {
			get() {
				return this.ORDER ? this.ORDER.lineItems : [];
			},
			set(obj) {
				return obj;
			},
		},
		orderNumber() {
			return this.ORDER && this.ORDER.orderNumber;
		},
	},
	mounted() {
		if (this.CART_ID) {
			this.$store.dispatch('CART_STORE/EMPTY_CART');
		}
		// const order = this.$route.query.order;
		//	if (order) {
		// await this.$store.dispatch('USER_STORE/GET_ORDER', { orderId: order });
		// try {
		// 	this.setOrderDetails();
		// } catch (e) {
		// 	// console.log(e)
		// }
		// }
	},
	methods: {
		createNextRefill(value) {
			if (value) {
				const d = new Date();
				d.setMonth(d.getMonth() + value);
				return this.$options.filters.formatDateAurora(d, 'MM/DD/YY');
			}
		},
		isFilter(item) {
			const isFilter =
				item &&
				item.productType &&
				item.productType.obj &&
				item.productType.obj.key &&
				item.productType.obj.key === 'filter';

			return isFilter;
		},
		setOrderDetails() {
			if (this.ORDER) {
				const {
					custom = {},
					paymentInfo: { payments = [] },
				} = this.ORDER;
				const { fields } = custom;
				const { holds } = fields;

				// Order Success always;
				this.isOrderConfirmed = true;

				if (holds && holds.length) {
					// Order has hold, display pending order title;
					this.isOrderConfirmed = false;

					// Order has hold, display corresponding hold message;
					holds.forEach((eachHold) => {
						switch (eachHold) {
							case 'FreightHold':
								this.isOrderPendingFreightMissing = true;
								break;
							case 'CreditHold':
								this.isOrderTermsPending = true;
								break;
							case 'TaxHold':
								this.isOrderTaxPending = true;
								break;
							default:
								// No valid hold,
								// Display success order title;
								this.isOrderConfirmed = true;
								break;
						}
					});
				}
				if (payments && payments.length) {
					try {
						// ACH Payment, Hide confirmed message;
						if (payments[0].obj.paymentMethodInfo.method === 'ACH') {
							// Display Pending order title
							this.isOrderConfirmed = false;

							// Display ACH Pending message;
							this.isOrderAchPaymentPending = true;
						}
					} catch (e) {
						// console.log(e)
					}
				}
			}
		},
	},
};
</script>
